<div class="page-wrapper">
    <div class="page test-runs">
        <zeb-page-header
            page-title="$ctrl.currentTitle">
        </zeb-page-header>
        <runs-filter ng-if="!$ctrl.isMobile"
            active-search-params="$ctrl.searchParams"
            on-search-save="$ctrl.saveSearch()"
            on-saved-searches-click="$ctrl.showSavedSearches()"
            on-search="$ctrl.onSearchParamsChange($params)"
            searches-list="$ctrl.savedSearches"
            selected-tests-runs-count="$ctrl.selectedTestRuns.length">
            <div class="test-runs__bulk"
                layout="row"
                layout-align="start center"
                ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:update', 'reporting:test-runs:read'])"
                ng-class="{ _active: $ctrl.selectedTestRuns.length }">
                <div class="test-runs__test-selection _all" flex="none">
                    <md-checkbox name="testCheckbox"
                        class="test-runs__test-checkbox"
                        aria-label="Select"
                        ng-model="$ctrl.selectedAll"
                        ng-change="$ctrl.selectAllTestRuns()"
                        ng-true-value="true"
                        ng-false-value="false">
                    </md-checkbox>
                </div>
                <div flex="auto" layout="row" class="test-runs__header-actions-btns">
                    <md-button id="bulkDeleteTestRuns"
                        ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:delete'])"
                        aria-label="menu"
                        class="zb-slim-btn _left-icon"
                        ng-really-message="Do you really want to delete multiple test runs?"
                        ng-really-click="$ctrl.batchDelete()">
                        <md-icon class="zb-slim-btn__icon">delete_outline</md-icon>
                        <span class="zb-slim-btn__txt">Delete</span>
                    </md-button>
                    <md-button id="bulkSendTestRunsAsEmail"
                        aria-label="menu"
                        class="zb-slim-btn _left-icon"
                        ng-click="$ctrl.batchEmail($event)">
                        <md-icon class="zb-slim-btn__icon">mail_outline</md-icon>
                        <span class="zb-slim-btn__txt">Send as email</span>
                    </md-button>

                    <md-menu md-offset="30 20" class="tab-additional__menu">
                        <div class="menu__button" aria-label="Additional menu" ng-click="$mdMenu.open($event)">
                            <span class="button-text">More</span>
                            <span class="material-icons button-icon">arrow_drop_down</span>
                        </div>
                        <md-menu-content class="tab-additional__menu-content">
                            <!--// TODO: refactor this after jenkins integration finished-->
<!--                            <md-menu-item class="menu__item" ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:read']) && $ctrl.isToolConnected('JENKINS')">-->
                            <md-menu-item class="menu__item" ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:read'])">
                                <md-button id="bulkRerunTestRuns"
                                    aria-label="menu"
                                    ng-disabled="!$ctrl.isAbleRebuildTestRuns"
                                    ng-really-message="Do you really want to rerun multiple test runs?"
                                    ng-really-click="$ctrl.batchRerun()">
                                    <span class="fa fa-undo" aria-hidden="true"></span>
                                    <span class="item-text" md-menu-align-target>Rerun</span>
                                </md-button>
                            </md-menu-item>
                            <md-menu-item class="menu__item" ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:read'])">
                                <md-button id="bulkAbortTestRuns"
                                    aria-label="menu"
                                    ng-disabled="!$ctrl.isAbleAbortTestRuns"
                                    ng-really-message="Do you really want to abort multiple test runs?"
                                    ng-really-click="$ctrl.abortSelectedTestRuns()">
                                    <span class="fa fa-ban" aria-hidden="true"></span>
                                    <span class="item-text" md-menu-align-target>Abort</span>
                                </md-button>
                            </md-menu-item>
                            <md-menu-item class="menu__item">
                                <md-button id="bulkCompareTestRuns"
                                    aria-label="menu"
                                    ng-disabled="!$ctrl.isAbleCompareTestRuns"
                                    ng-click="$ctrl.showCompareDialog($event)">
                                    <span class="fa fa-columns" aria-hidden="true"></span>
                                    <span class="item-text" md-menu-align-target>Compare</span>
                                </md-button>
                            </md-menu-item>
                        </md-menu-content>
                    </md-menu>
                </div>
                <md-button id="closeBulkActions"
                    flex="none"
                    class="md-icon-button _default-md-style"
                    ng-click="$ctrl.clearTestRunsSelection()">
                    <md-icon aria-label="Reset selection">close</md-icon>
                </md-button>
            </div>
        </runs-filter>
        <runs-filter-mobile ng-if="$ctrl.isMobile"
            active-search-params="$ctrl.searchParams"
            on-filter-create="$ctrl.showMobileFiltersDialog($event)"
            on-search="$ctrl.onSearchParamsChange($params)"
            on-search-apply="$ctrl.onSavedSearchApply($searchTemplate)"
            on-search-save="$ctrl.saveSearch()"
            on-saved-searches-click="$ctrl.showSavedSearches()"
            searches-list="$ctrl.savedSearches">
            <div class="test-runs__bulk _mobile"
                layout="row"
                layout-align="start center"
                ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:update', 'reporting:test-runs:read'])"
                ng-class="{ _active: $ctrl.selectedTestRuns.length }">
                <div class="test-runs__test-selection _all" flex="none">
                    <md-checkbox name="testCheckbox"
                        class="test-runs__test-checkbox"
                        aria-label="Select"
                        ng-model="$ctrl.selectedAll"
                        ng-change="$ctrl.selectAllTestRuns()"
                        ng-true-value="true"
                        ng-false-value="false">
                    </md-checkbox>
                </div>
                <div flex="auto" layout="row" class="test-runs__header-actions-btns">
                    <md-button id="bulkDeleteTestRunsMobile"
                        ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:delete'])"
                        aria-label="menu"
                        class="zb-slim-btn _left-icon _delete"
                        ng-really-message="Do you really want to delete multiple test runs?"
                        ng-really-click="$ctrl.batchDelete()">
                        <md-icon class="zb-slim-btn__icon">delete_outline</md-icon>
                        <span class="zb-slim-btn__txt">Delete</span>
                    </md-button>
                    <md-button id="bulkSendTestRunsAsEmailMobile"
                        aria-label="menu"
                        class="zb-slim-btn _left-icon _send-email"
                        ng-click="$ctrl.batchEmail($event)">
                        <md-icon class="zb-slim-btn__icon">mail_outline</md-icon>
                        <span class="zb-slim-btn__txt">Send as email</span>
                    </md-button>

                    <md-menu md-offset="30 20" class="tab-additional__menu">
                        <div class="menu__button _more" aria-label="Additional menu" ng-click="$mdMenu.open($event)">
                            <span class="button-text">More</span>
                            <span class="material-icons button-icon">arrow_drop_down</span>
                        </div>
                        <md-menu-content class="tab-additional__menu-content">
<!--                            // TODO: refactor this after jenkins integration finished-->
<!--                            <md-menu-item class="menu__item" ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:read']) && $ctrl.isToolConnected('JENKINS')">-->
                            <md-menu-item class="menu__item" ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:read'])">
                                <md-button id="bulkRerunTestRunsMobile"
                                    aria-label="menu"
                                    ng-disabled="!$ctrl.isAbleRebuildTestRuns"
                                    ng-really-message="Do you really want to rerun multiple test runs?"
                                    ng-really-click="$ctrl.batchRerun()">
                                    <span class="fa fa-undo" aria-hidden="true"></span>
                                    <span class="item-text" md-menu-align-target>Rerun</span>
                                </md-button>
                            </md-menu-item>
                            <md-menu-item class="menu__item" ng-if="$ctrl.userHasAnyPermission(['reporting:test-runs:read'])">
                                <md-button id="bulkAbortTestRunsMobile"
                                    aria-label="menu"
                                    ng-disabled="!$ctrl.isAbleAbortTestRuns"
                                    ng-really-message="Do you really want to abort multiple test runs?"
                                    ng-really-click="$ctrl.abortSelectedTestRuns()">
                                    <span class="fa fa-ban" aria-hidden="true"></span>
                                    <span class="item-text" md-menu-align-target>Abort</span>
                                </md-button>
                            </md-menu-item>
                            <md-menu-item class="menu__item">
                                <md-button id="bulkCompareTestRunsMobile"
                                    aria-label="menu"
                                    ng-disabled="!$ctrl.isAbleCompareTestRuns"
                                    ng-click="$ctrl.showCompareDialog($event)">
                                    <span class="fa fa-columns" aria-hidden="true"></span>
                                    <span class="item-text" md-menu-align-target>Compare</span>
                                </md-button>
                            </md-menu-item>
                        </md-menu-content>
                    </md-menu>
                </div>
                <md-button id="closeBulkActionsMobile"
                    flex="none"
                    class="md-icon-button _default-md-style"
                    ng-click="$ctrl.clearTestRunsSelection()">
                    <md-icon aria-label="Reset selection">close</md-icon>
                </md-button>
            </div>
        </runs-filter-mobile>

        <div class="p-tests-runs__content-wrapper"
            blur-filter
            blur-radius="1px"
            blur-active="{{$ctrl.isUserParamSaving}}">
            <div class="p-tests-runs__section _content row ui-section no-margin">
                <div class="col-md-12 no-padding">
                    <article class="article">
                        <md-card class="no-margin-h">
                            <test-run-card test-run="launcher"
                                is-notification-available="$ctrl.isNotificationAvailable"
                                ng-repeat="launcher in $ctrl.launchers | orderObjectBy:'startedAt':true track by launcher.ciRunId"
                                single-mode="false"></test-run-card>
                            <test-run-card test-run="testRun"
                                ng-repeat="testRun in $ctrl.testRuns | orderObjectBy:'startedAt':true track by testRun.id"
                                is-notification-available="$ctrl.isNotificationAvailable"
                                single-mode="false" on-select="$ctrl.selectTestRun(testRun)"
                                on-delete="$ctrl.deleteSingleTestRun(testRun)"></test-run-card>
                            <div ng-if="$ctrl.isTestRunsEmpty && $ctrl.isSearchActive && !$ctrl.isFetchingTestsRuns && !$ctrl.fromWizard">
                                <div id="noData" class="text-center p-tests-runs__no-content">No test runs matching selected criteria</div>
                            </div>
                            <div ng-if="$ctrl.isTestRunsEmpty && !$ctrl.isSearchActive && !$ctrl.isFetchingTestsRuns && !$ctrl.fromWizard">
                                <div id="noDataYet" class="text-center p-tests-runs__no-content">No test runs yet</div>
                            </div>
                            <md-table-pagination id="pagination"
                                zafira-background-theme="pagination"
                                ng-if="!$ctrl.isTestRunsEmpty"
                                md-limit="$ctrl.pageSize"
                                md-limit-options=false
                                md-page="$ctrl.currentPage"
                                md-total="{{$ctrl.totalResults}}"
                                md-page-select=false
                                md-boundary-links=true
                                md-on-paginate="$ctrl.onPageChange"></md-table-pagination>
                        </md-card>
                    </article>
                </div>
            </div>
        </div>
    </div>
    <md-sidenav class="md-sidenav-right"
        md-component-id="saved-searches-sidenav"
        md-disable-backdrop=""
        md-whiteframe="1">

        <saved-searches
            is-search-saving="$ctrl.savingSearch"
            on-search-save="$ctrl.onSavedSearchAdd($searchTemplate)"
            on-search-apply="$ctrl.onSavedSearchApply($searchTemplate)"
            on-search-delete="$ctrl.onSavedSearchDelete($searchId)"
            on-search-update="$ctrl.onSavedSearchUpdate()"
            params-to-save="$ctrl.searchParamsToSave"
            searches-list="$ctrl.savedSearches"
            on-close="$ctrl.hideSavedSearches()"></saved-searches>
    </md-sidenav>
    <div class="p-tests-runs__wizard-message-container" ng-if="!$ctrl.isFetchingTestsRuns && $ctrl.isTestRunsEmpty && !$ctrl.isSearchActive && $ctrl.fromWizard">
        <div class="p-tests-runs__wizard-message-wrapper">
            <md-icon class="material-icons p-tests-runs__wizard-message-icon">check_circle_outline</md-icon>
            <div class="p-tests-runs__wizard-message-header">Congrats! You successfully integrated your tests into Zebrunner.</div>
            <div class="p-tests-runs__wizard-message-text">Now, run your tests to get your first test results.</div>
        </div>
    </div>
</div>
